{'*****************************
''* Keyboard input sample v1.0   *
''*  2008-02-14  *
''*****************************
''      Filename:InputSample.spin

Sample code to demonstrate how to input numbers on a keypad and present it on a videomonitor.
Enter as many digits you want and finish by pressing enter key.

}
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


VAR
  Byte datain[16]
  Byte  Delimiter           
OBJ
  text          :"tv_text"                              
  kb            :"Keyboard"
  num           :"Numbers"
  Fm            :"FloatMath"   
PUB Main | value 

  text.start(12)                'Video  

  text.str(string("Waits for keypad input i.e 789 and then press enter",13))
    'start the keyboard
  kb.start(26, 27)


  repeat
    RxStr (@dataIn)
    text.str(@datain)
    text.out(13)
    Value:=num.FromStr(@datain,10)
    value:=value/2              ' example
    text.dec(value)
    text.out(13)

PUB RxStr (stringptr) : Value | ptr
{{
  Accepts a string of characters - up to 15 - to be passed by reference
  String acceptance terminates with a carriage return or the defined delimiter character.
  Will accept up to 15 characters before passing back.
  Serial.Rxstr(@MyStr)        ' accept
  serial.str(@MyStr)          ' transmit
 }} 
    ptr:=0
    bytefill(@dataIn,0,15)                               
   dataIn[ptr] :=  kb.getkey'uart.Rx        
   ptr++                                                  
   repeat while ((DataIn[ptr-1] <> 13) and (DataIn[ptr-1] <> Delimiter)) and (ptr < 15)       
       dataIn[ptr] :=  kb.getkey'uart.RX    
       ptr++
   dataIn[ptr-1]:=0                                         
   byteMove(stringptr,@datain,16)

